import java.io.*;
import java.nio.*;
import java.nio.charset.*;

public class TimeCharset {
        static final String cset1str = "UTF-8";
        static final String cset2str = "ISO-8859-2";
        static final String cset3str = "ISO-8859-8";

	static final Charset cset1 = Charset.forName(cset1str);
	static final Charset cset2 = Charset.forName(cset2str);
	static final Charset cset3 = Charset.forName(cset3str);

	public static void main(String args[]) throws Exception {
		String data = args[0];

		int limit = 10000000;
		System.out.println("Doing " + limit + " iterations of each for string - '" + data + "'");

		long t1, t2;

		t1 = System.currentTimeMillis();
		for (int i=0; i<limit; i++) {
			data.getBytes(cset1);
			data.getBytes(cset2);
			data.getBytes(cset3);
		}
		t2 = System.currentTimeMillis();
		System.out.println((t2-t1) + " getBytes(Charset)");


		t1 = System.currentTimeMillis();
		for (int i=0; i<limit; i++) {
			data.getBytes(cset1);
			data.getBytes(cset2);
			data.getBytes(cset3);
		}

		t2 = System.currentTimeMillis();
		System.out.println((t2-t1) + " getBytes(String)");

		t1 = System.currentTimeMillis();
		for (int i=0; i<limit; i++) {
			ByteBuffer buf = cset1.encode(CharBuffer.wrap(data));
			byte b[] = new byte[buf.limit()];
			buf.get(b, 0, buf.limit());

			ByteBuffer buf2 = cset2.encode(CharBuffer.wrap(data));
			byte b2[] = new byte[buf2.limit()];
			buf2.get(b2, 0, buf2.limit());

			ByteBuffer buf3 = cset3.encode(CharBuffer.wrap(data));
			byte b3[] = new byte[buf3.limit()];
			buf3.get(b3, 0, buf3.limit());
		}
		t2 = System.currentTimeMillis();
		System.out.println((t2-t1) + " via ByteBuffer");
	}
}

